#include <iostream>
#include <stdio.h>
#include<algorithm>
using namespace std;

int main()
{
    int n,k;
    scanf("%d%d",&n,&k);
    int niz[n*n-1];
    for(int i=0;i<=n*n-1;i++)
    {
        int a;
        scanf("%d",&a);
        niz[i]=a;
    }
    int ali[n*n-1],o=1,l=0,u=0;
    while(o<=k)
    {
        for(int i=0;i<n*n-1;i++)
        {
            if(niz[i]==o)
            {
                ali[l]=i;
                l++;
            }
        }
        int ost[l-1],kol[l-1],g,h;//,g,h,v,w;
        for(int i=0;i<l;i++)
        {
            ost[i]=ali[i]%n;
            kol[i]=ali[i]/n;
        }
        sort(ost,ost+l);
        sort(kol,kol+l);
        g=ost[l-1]-ost[0]+1;
        h=kol[l-1]-kol[0]+1;
        if(g*h==l)
            u++;
        o++;
        l=0;
    }
    printf("%d",u);
    return 0;
}